unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, IdHTTPServer,
  IdCustomHTTPServer, IdContext, IdCustomTCPServer, IdTCPServer, IdSocksServer,
  IdComponent, IdCoderMIME, DCPsha1, idGlobal;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    DCP_sha1_1: TDCP_sha1;
    Edit1: TEdit;
    IdEncoderMIME1: TIdEncoderMIME;
    IdHTTPServer1: TIdHTTPServer;
    IdSocksServer1: TIdSocksServer;
    IdTCPServer1: TIdTCPServer;
    Memo1: TMemo;
    Memo2: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure IdHTTPServer1CommandGet(AContext: TIdContext;
      ARequestInfo: TIdHTTPRequestInfo; AResponseInfo: TIdHTTPResponseInfo);
    procedure IdHTTPServer1Connect(AContext: TIdContext);
    procedure IdHTTPServer1Disconnect(AContext: TIdContext);
    procedure IdSocksServer1Connect(AContext: TIdContext);
    procedure IdSocksServer1ContextCreated(AContext: TIdContext);
    procedure IdSocksServer1ListenException(AThread: TIdListenerThread;
      AException: Exception);
    procedure IdSocksServer1Status(ASender: TObject; const AStatus: TIdStatus;
      const AStatusText: string);
    procedure IdTCPServer1Connect(AContext: TIdContext);
    procedure IdTCPServer1Disconnect(AContext: TIdContext);
    procedure IdTCPServer1Execute(AContext: TIdContext);
  private

  public

  end;

var
  Form1: TForm1;
   key:string;
implementation
uses cHash,IdHashSHA;
{$R *.frm}

{ TForm1 }
 function handShake(str:string):string;


begin

 Result := TIdEncoderMIME.EncodeBytes( TIdHashSHA1.Create.HashString(str + '258EAFA5-E914-47DA-95CA-C5AB0DC85B11') );
end;
 function String2Hex(const Buffer: AnsiString): string;
 begin
   SetLength(Result, Length(Buffer) * 2);
   BinToHex(PAnsiChar(Buffer), PChar(Result), Length(Buffer));
 end;

 function Hex2String(const Buffer: string): AnsiString;
 begin
   SetLength(Result, Length(Buffer) div 2);
   HexToBin(PChar(Buffer), PAnsiChar(Result), Length(Result));
 end;



procedure TForm1.Button1Click(Sender: TObject);
begin
  if form1.IdHTTPServer1.Active=false then form1.IdHTTPServer1.Active:=true else
      begin

        form1.IdHTTPServer1.Active:=false;
      end;
  if form1.IdTCPServer1.Active=false then form1.IdTCPServer1.Active:=true else
      begin

        form1.IdTCPServer1.Active:=false;

      end;
  if form1.IdHTTPServer1.Active=true then
      begin
      form1.Memo1.Lines.Add('Server started');
      form1.Button1.Caption:='Stop';
      end
      else
      begin
      form1.Memo1.Lines.Add('Server shotdown');
      form1.Button1.Caption:='Start';
      end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
Base:string;
base64String: string;
begin
  Base:=SHA1DigestAsString(CalcSHA1(edit1.Text+'258EAFA5-E914-47DA-95CA-C5AB0DC85B11'));
  base64String:=TIdEncoderMIME.EncodeBytes(ToBytes(Base));
  form1.Memo1.Lines.Add(base64String);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
Response: TStringList;
begin
  Response := TStringList.Create;
  Response.Add('HTTP/1.1 101 Switching Protocols');
  response.Add('Upgrade: websocket');
  response.Add('Connection: Upgrade');
  response.Add('Sec-WebSocket-Accept: XJ5oIwgkPS19PNMxp3UvbKsDl48=');
  response.Add('Sec-WebSocket-Version: 13');
  form1.Memo1.Lines.Add(response.GetText);
  Response.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Self.IdHTTPServer1.Active:=False;
end;

procedure TForm1.IdHTTPServer1CommandGet(AContext: TIdContext;
  ARequestInfo: TIdHTTPRequestInfo; AResponseInfo: TIdHTTPResponseInfo);
begin

 //AResponseInfo.ContentType := 'text/html; charset=windows-1251';   utf-8
    AResponseInfo.ContentType := 'text/html; charset=utf-8';
 if ARequestInfo.Document = '/' then AResponseInfo.ContentStream:=TFileStream.Create ('site2/index.html',fmOpenRead) else  AResponseInfo.ContentStream := TFileStream.Create('site2' + ARequestInfo.Document,fmOpenRead);
  form1.Memo1.Lines.Add(ARequestInfo.Document);

  {if (ARequestInfo.Document <> '/')  then
    Begin
       AResponseInfo.ContentStream := TFileStream.Create('site2' + ARequestInfo.Document,fmOpenRead);

    end;       }


//if ARequestInfo.Document='/' then AResponseInfo.ContentStream:=TFileStream.Create (ARequestInfo.Document,fmOpenRead);






end;

procedure TForm1.IdHTTPServer1Connect(AContext: TIdContext);
begin
  form1.Memo1.Lines.Add('Client '+Acontext.Connection.Socket.Binding.PeerIP+' connect');
end;

procedure TForm1.IdHTTPServer1Disconnect(AContext: TIdContext);
begin
  form1.Memo1.Lines.Add('Client '+Acontext.Connection.Socket.Binding.PeerIP+' Disconnect');
end;

procedure TForm1.IdSocksServer1Connect(AContext: TIdContext);
begin

 form1.Memo1.Lines.Add('try to Socket connect');
  form1.Memo1.Lines.Add(Acontext.Connection.Socket.ReadLn);
end;

procedure TForm1.IdSocksServer1ContextCreated(AContext: TIdContext);
begin
  form1.Memo1.Lines.Add(Acontext.Connection.Socket.ReadLn);
end;

procedure TForm1.IdSocksServer1ListenException(AThread: TIdListenerThread;
  AException: Exception);
begin

end;

procedure TForm1.IdSocksServer1Status(ASender: TObject;
  const AStatus: TIdStatus; const AStatusText: string);
begin

end;

procedure TForm1.IdTCPServer1Connect(AContext: TIdContext);
begin
  form1.Memo1.Lines.Add('try to TCP connect');
end;

procedure TForm1.IdTCPServer1Disconnect(AContext: TIdContext);
begin
  form1.Memo1.Lines.Add('TCP Disconnect');
end;

procedure TForm1.IdTCPServer1Execute(AContext: TIdContext);
var
str:AnsiString;
Response: TStringList;
begin
 str:='';
 str:=Acontext.Connection.Socket.ReadLn;

 if str<>'' then form1.Memo1.Lines.Add(str);
 form1.Memo1.Lines.Add(': '+String2Hex(str));

 if pos('Sec-WebSocket-Key:',str)=1 then
      begin
        key:=handShake(copy(str,20,length(str)));
        form1.Edit1.text:=key;
      end;

  if pos('Sec-WebSocket-Extensions',str)=1 then
          begin

            form1.Memo2.Lines.Add('Key: '+key);
            Response := TStringList.Create;
            Response.Add('HTTP/1.1 101 Switching Protocols');
            response.Add('Upgrade: websocket');
            response.Add('Connection: Upgrade');
            response.Add('Sec-WebSocket-Accept: '+key);
            response.Add('Sec-WebSocket-Version: 13');

            form1.Memo1.Lines.Add('');
            Acontext.Connection.Socket.WriteLn(response.GetText);


            Response.Free;
          end;


end;

end.

